const {serverConfig} = require('../../src/config.js')
const {getSWCConfig} = require('@s-ui/typescript-config')

const {
  forceTranspilation = [],
  esmOverride = false,
  useLibDir = false
} = serverConfig

const regexToAdd = forceTranspilation.map(
  regexString => new RegExp(regexString)
)

if (esmOverride) {
  require('./applyEsmOverride.js')
}

const libDir = /lib/
const paths = [
  /@babel\/runtime/,
  /@s-ui/,
  /mocks/,
  /src/,
  /test/,
  libDir,
  ...regexToAdd
]

require('@swc/register')({
  only: useLibDir ? paths : paths.filter(path => path !== libDir),
  presets: [
    [
      'babel-preset-sui',
      {
        useESModules: false
      }
    ]
  ],
  plugins: [
    'babel-plugin-dynamic-import-node',
    '@babel/plugin-transform-modules-commonjs'
  ],
  ...getSWCConfig({isTypeScript: true})
})

// require('@babel/register')({
//   ignore: [],
//   only: useLibDir ? paths : paths.filter(path => path !== libDir),
//   presets: [
//     [
//       'babel-preset-sui',
//       {
//         useESModules: false
//       }
//     ]
//   ],
//   plugins: [
//     'babel-plugin-dynamic-import-node',
//     '@babel/plugin-transform-modules-commonjs'
//   ]
// })
